#ifndef GESTION_ECRAN_H_

# define GESTION_ECRAN_H_

# include <stdlib.h>
# include <SDL/SDL.h>
# include <SDL/SDL_image.h>


typedef	struct s_screen
{
	SDL_Surface *surface;			//The surface where to blit
	int width;						//Width of the screen
	int height;						//Height of the screen
	int x_world;					//X position of the screen in the world
	int y_world;					//Y position of the screen in the world
	int last_x;						//Last X position of the screen in the world
	int last_y;						//Last Y position of the screen in the world
} s_screen;

/*
** Create the screen, give it's width and height max, and the beginning position
*/
s_screen *create_screen(int width,
						int height,
						int x,
						int y);

/*
** Free the screen structure, and if possible, the SDL_Surface*
*/
void free_screen(s_screen *screen);

/*
** Update the screen X & Y positions by keeping the old position,
** and putting new coordinates
*/
void update_screen_xy(s_screen *screen,
					  int new_x,
					  int new_y);

/*
** Update the screen X position by keeping the old position,
** and putting new coordinates
*/
void update_screen_x(s_screen *screen,
					 int new_x);

/*
** Update the screen Y position by keeping the old position,
** and putting new coordinates
*/
void update_screen_y(s_screen *screen,
					 int new_y);

#endif /* !GESTION_ECRAN_H_ */
