#ifndef GESTION_MONDE_H_

# define GESTION_MONDE_H_

# include <stdlib.h>
# include <SDL/SDL.h>
# include <SDL/SDL_image.h>

# include "lib_personnage.h"
# include "lib_decors.h"

typedef	struct s_world
{
	struct s_personnage **vilains;			//The array with all ennemies
	struct s_personnage *hero;				//The main character
	struct s_sblink_decor **blinking_decor;	//The array with all blinking decors
	struct s_decor **normal_decor;			//The array with all non-blinking decor
	int x_begin;							//X position, of the beginning for hero
	int y_begin;							//Y position, of the beginning for hero
	int w;									//X lenght of the world
	int h;									//Y lenght of the world
} s_world;

/*
** ATTENTION ! Aucune gestion de l'arriere plan statique...
** A implementer pour permettre le choix aux devs d'en mettre un !
** Mais pas obligatoire...
** Proposer aussi un tab** par plan
** dans chaque case le pointeur vers la sprite a animer...
** En plus : un tab* en parallele qui servira d'ordonnanceur en reduisant un int
** a chaque tour avant d'animer.. a 0, on update le plan en appelant le
** "update_decor" sur chaque element du plan (tab**)
** Pourquoi pas : un tab***...
** tab[0] == tout premier plan contenant un tableau de persos/decors,
** tab[5] == 6e plan, ...
** + une variable pour le plan du heros ?... + une variable pour le nb de plans
**
** Tout ca necessiterait de refaire tout le moteur graphique et physique !
*/


/*
** Create the world, give the X beginning position and Y one of the main character
** and give the X and Y lenght of the world. (it will determine the screen moves)
*/
s_world *create_world(int x_begin,
					  int y_begin,
					  int w,
					  int h);

/*
** Free the vilains, and the hero !
** But NOT the vilains **, NEITHER the decors,
** NEITHER the other variables in the structure.
** It is complementary to the free_world, and free_decors_in_world.
*/
void free_peoples_in_world(s_world *world);

/*
** Free the decor (non-blinking) and the blinking decor.
** But NOT the blinking_decor**, NEITHER normal_decor**,
** NEITHER the vilains, NEITHER hero, NEITHER other variables.
** It is complementary to the free_world, and free_people_in_world.
*/
void free_decors_in_world(s_world *world);

/*
** Free the world structure only...
*/
void free_world(s_world *world);

#endif /* !GESTION_MONDE_H_ */
