#include "main.h"

char **make_char_array(int nb_char, ...)
{
	va_list arglist;
	char **char_array = NULL;
	char *char_tmp = NULL;
	int i = 0;

	va_start(arglist, nb_char);
	char_array = malloc((nb_char + 1) * sizeof (char*));
	char_array[nb_char] = NULL;
	while (i != nb_char)
	{
		char_tmp = va_arg(arglist, char*);
		if (char_tmp == NULL)
		{
			va_end(arglist);
			free(char_array);
			return (NULL);
		}
		char_array[i] = char_tmp;
		i++;
	}
	va_end(arglist);
	return (char_array);
}

void free_structure_char_array(char **char_array)
{
	free(char_array);
}

void free_everything_char_array(char **char_array)
{
	int i = 0;

	while (char_array[i] != NULL)
	{
		free(char_array[i]);
		i++;
	}
	free(char_array);
}


int main(int argc, char **argv)
{
	SDL_Event event;
	SDL_Surface *screen = NULL;
	s_screen *ecran = NULL;
	s_world *world = NULL;
	s_decor *background = NULL;
	s_decor *plateform = NULL;
	s_decor *icepeak = NULL;
	s_decor *snow = NULL;
	s_sblink_decor *bvessel1 = NULL;
	s_sblink_decor *bvessel2 = NULL;
	s_personnage *X = NULL;
	s_personnage *Balloon = NULL;
	s_personnage **vilains = NULL;

	char *tab_x_running[] = {".\\Ressources\\x_running\\x02.bmp", ".\\Ressources\\x_running\\x03.bmp", ".\\Ressources\\x_running\\x04.bmp", ".\\Ressources\\x_running\\x05.bmp", ".\\Ressources\\x_running\\x06.bmp", ".\\Ressources\\x_running\\x07.bmp", ".\\Ressources\\x_running\\x08.bmp", ".\\Ressources\\x_running\\x09.bmp", ".\\Ressources\\x_running\\x10.bmp", ".\\Ressources\\x_running\\x11.bmp", NULL};
	//char **tab_x_running = NULL;
	s_sprite **test_sprite = NULL;
	s_sblink_decor **test_blink = NULL;
	s_decor **test_decor = NULL;
	char *tab_x_waiting[] = {".\\Ressources\\x_waiting\\x_waiting1.bmp", ".\\Ressources\\x_waiting\\x_waiting1.bmp", ".\\Ressources\\x_waiting\\x_waiting1.bmp", ".\\Ressources\\x_waiting\\x_waiting2.bmp", ".\\Ressources\\x_waiting\\x_waiting3.bmp", NULL};
	char *tab_balloon_flying[] = {".\\Ressources\\balloon\\balloon1.bmp", ".\\Ressources\\balloon\\balloon2.bmp", ".\\Ressources\\balloon\\balloon3.bmp", NULL};
	char *tab_balloon_open[] = {".\\Ressources\\balloon\\openballoon1.bmp", ".\\Ressources\\balloon\\openballoon2.bmp", NULL};
	s_sprite *megaman_x_running = NULL;
	s_sprite *megaman_x_waiting = NULL;
	s_sprite *balloon_flying = NULL;
	s_sprite *balloon_open = NULL;
	simple_blinking_surface *vessel1 = NULL;
	simple_blinking_surface *vessel2 = NULL;

	int continuer = 1;
	int balloon_move = 0;
	int balloon_direction = 1;
	int x_camera = 0;
	
	int dec = 0;


	//tab_x_running = make_char_array(10, ".\\Ressources\\x_running\\x02.bmp", ".\\Ressources\\x_running\\x03.bmp", ".\\Ressources\\x_running\\x04.bmp", ".\\Ressources\\x_running\\x05.bmp", ".\\Ressources\\x_running\\x06.bmp", ".\\Ressources\\x_running\\x07.bmp", ".\\Ressources\\x_running\\x08.bmp", ".\\Ressources\\x_running\\x09.bmp", ".\\Ressources\\x_running\\x10.bmp", ".\\Ressources\\x_running\\x11.bmp");
	ecran = create_screen(256, 256, 0, 0);
	world = create_world(0, 189, 512, 256);

	SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER);
	SDL_WM_SetCaption("Blink Test", NULL);
	screen = SDL_SetVideoMode(ecran->width, ecran->height, 32, SDL_HWSURFACE | SDL_DOUBLEBUF);
	ecran->surface = screen;

	SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 255, 255, 255));

	vessel1 = create_simple_surface(".\\Ressources\\background\\blink1_1.bmp", ".\\Ressources\\background\\blink1_2.bmp", 1, 20, 78, 116, 0, 0, 0);
	vessel2 = create_simple_surface(".\\Ressources\\background\\blink2_1.bmp", ".\\Ressources\\background\\blink2_2.bmp", 1, 20, 73, 181, 0, 0, 0);

	bvessel1 = create_sblink_decor(vessel1, 78, 116);
	bvessel2 = create_sblink_decor(vessel2, 73, 181);
	bvessel1->is_displayed = 0;
	bvessel2->is_displayed = 0;

	test_blink = make_sblink_decor_array(2, bvessel1, bvessel2);
	world->blinking_decor = test_blink;


	megaman_x_running = create_sprite(tab_x_running, 0, 0, 189, 255, 255, 255);
	megaman_x_waiting = create_sprite(tab_x_waiting, 0, (512 - 30), 189, 255, 255, 255);
	balloon_flying = create_sprite(tab_balloon_flying, 0, 100, 60, 255, 255, 255);
	balloon_open = create_sprite(tab_balloon_open, 0, 50, 20, 255, 255, 255);


	background = create_decor(".\\Ressources\\background\\background.bmp", 0, 0, 0, 0, 0);
	plateform = create_decor(".\\Ressources\\background\\plateform.bmp", 0, 112, 0, 0, 0);
	icepeak = create_decor(".\\Ressources\\background\\icepeak.bmp", 130, 168, 0, 0, 0);
	snow = create_decor(".\\Ressources\\background\\snow.bmp", 0, 0, 0, 0, 0);

	background->is_displayed = 0;
	plateform->is_displayed = 0;
	icepeak->is_displayed = 0;

	//plateform->positionDst.x = 0;
	//plateform->positionDst.y = 112;
	plateform->positionSrc.w = 256;
	plateform->positionSrc.h = 256;

	//icepeak->positionDst.x = 130;
	//icepeak->positionDst.y = 168;
	icepeak->positionSrc.w = 71;
	icepeak->positionSrc.h = 56;

	test_decor = make_decor_array(3, plateform, icepeak, snow);
	world->normal_decor = test_decor;
	//ATTENTION ! Le background n'est PAS inclus dedans ! Car il ne doit PAS etre deplace ou modifie !

	test_sprite = malloc(3 * sizeof (s_sprite*));
	test_sprite[0] = balloon_flying;
	test_sprite[1] = balloon_open;
	test_sprite[2] = NULL;

	Balloon = create_personnage(test_sprite, 2, 100, 60);
	Balloon->is_displayed = 0;

	vilains = make_personnage_array(1, Balloon);
	world->vilains = vilains;

	test_sprite = malloc(3 * sizeof (s_sprite*));
	test_sprite[0] = megaman_x_waiting;
	test_sprite[1] = megaman_x_running;
	test_sprite[2] = NULL;
	
	//test_sprite = make_sprite_array(2, megaman_x_waiting, megaman_x_running);
	X = create_personnage(test_sprite, 2, 0, 189);
	world->hero = X;
	change_sprite_personnage(X, 1);
	X->is_displayed = 0;


	while (continuer == 1)
	{
		SDL_PollEvent(&event);
        switch(event.type)
        {
            case SDL_QUIT:
                continuer = 0;
        }

		//BLITTING
		blit_decor(background, screen);
		blit_decor(plateform, screen);

		//blit_simple_blinking_surface(vessel1, screen);
		//blit_simple_blinking_surface(vessel2, screen);
		blit_sblink_decor(bvessel1, screen);
		blit_sblink_decor(bvessel2, screen);

		blit_personnage(X, screen);			
		blit_personnage(Balloon, screen);

		blit_decor(icepeak, screen);
		//blit_decor(snow, screen);

		//AFFICHAGE
		SDL_Flip(screen);


		//MISE A JOUR (PAS ENCORE BIEN BIEN TRIEE)
		//update_simple_blinking(vessel1);
		//update_simple_blinking(vessel2);
		update_sblink_decor(bvessel1);
		update_sblink_decor(bvessel2);


		//MOUVEMENTS
		//MONDE : Ca avance vers la droite, si on n'est pas au bout
		if ((plateform->x_world + plateform->image->w) < ecran->x_world)
			plateform->is_displayed = 1;
		else
		{
			//On efface la sprite au fur et a mesure qu'elle defile
			//if ((plateform->x_world - ecran->x_world) < 0)
			if (((plateform->image->w - plateform->positionSrc.x) > ecran->width) 
				&& ((plateform->x_world - ecran->x_world) < 0))
			{
				plateform->positionSrc.x += 1;//(plateform->x_world - ecran->x_world);
				//plateform->positionSrc.w -= 1;//(plateform->x_world - ecran->x_world);
			}
		}

		//ICEPEAK : On verifie si la sprite a encore un interet a etre affichee
		if ((icepeak->x_world + icepeak->image->w) < ecran->x_world)
			icepeak->is_displayed = 1;
		else
		{
			//On efface la sprite au fur et a mesure qu'elle defile
			if ((icepeak->x_world - ecran->x_world) < 0)
			{
				icepeak->positionSrc.x += 1;//(icepeak->x_world - ecran->x_world);
				//icepeak->positionSrc.w -= 1;//(icepeak->x_world - ecran->x_world);
			}
		}

		//BVESSEL1 : On verifie si la sprite a encore un interet a etre affichee
		if ((bvessel1->x_world + bvessel1->image->w) < ecran->x_world)
			bvessel1->is_displayed = 1;
		else
		{
			//On efface la sprite au fur et a mesure qu'elle defile
			if ((bvessel1->x_world - ecran->x_world) < 0)
			{
				bvessel1->positionSrc.x += 1;//(bvessel1->x_world - ecran->x_world);
				//bvessel1->positionSrc.w -= 1;//(bvessel1->x_world - ecran->x_world);
			}
		}

		//BVESSEL2 : On verifie si la sprite a encore un interet a etre affichee
		if ((bvessel2->x_world + bvessel2->image->w) < ecran->x_world)
			bvessel2->is_displayed = 1;
		else
		{
			//On efface la sprite au fur et a mesure qu'elle defile
			if ((bvessel2->x_world - ecran->x_world) < 0)
			{
				bvessel2->positionSrc.x += 1;//(bvessel2->x_world - ecran->x_world);
				//bvessel2->positionSrc.w -= 1;//(bvessel2->x_world - ecran->x_world);
			}
		}


		//MMX PART
		//On stoppe X si il courait, au bout du monde
		if ((X->x_world + X->sprites[X->current_sprite]->width) == world->w)
		{
			if (X->current_sprite != 0)
			{
				change_sprite_personnage(X, 0);
			}
		}
		else
		{
			//MMX avance si il peut
			X->x_world += 1; //Update dans le monde
		}
		update_personnage(X); //Update de la sprite affichee


		//BALLOON PART
		//On fait peter le ballon si X passe en dessous 
		if (X->x_world == Balloon->x_world)
		{
			change_sprite_personnage(Balloon, 1);
		}

		//Affichage et comportement du ballon
		if (Balloon->current_sprite == 0)
		{
			//Ballon flotte tranquillement
			if ((balloon_move == 3) || (balloon_move == -3))
				balloon_direction *= (-1);
			balloon_move += balloon_direction;
			Balloon->y_world += balloon_direction;
			Balloon->positionDst.y += balloon_direction;
		}
		else
		{
			//Ballon s'envole
			Balloon->positionDst.y -= 1;
		}
		update_personnage(Balloon);


		//Camera
		if (!((ecran->width + ecran->x_world) >= world->w))
		{
			if /*(*/(((ecran->width + ecran->x_world) - (X->x_world + X->sprites[X->current_sprite]->width)) < CAMERA_GAP)/* ||
			((X->x_world - ecran->x_world) < CAMERA_GAP))*/
			{
				//Si X arrive a moins de 30 pixels du bord droit...
				if (((ecran->width + ecran->x_world) - (X->x_world + X->sprites[X->current_sprite]->width)) < CAMERA_GAP)
				{
					//Ca avance vers la droite... + test de fin du monde a droite
					if ((ecran->x_world + ecran->width) != world->w)
					{
						ecran->x_world += 1;
						//int dec = 0;

						dec = 0;
						while (world->blinking_decor[dec] != NULL)
						{
							world->blinking_decor[dec]->positionDst.x -= 1;
							dec++;
						}

						dec = 0;
						while (world->normal_decor[dec] != NULL)
						{
							if (((ecran->x_world + ecran->width) < world->w) && (dec == 0)) //Plateform
								world->normal_decor[0]->positionDst.x -= 1;
							else
								world->normal_decor[dec]->positionDst.x -= 1;
							dec++;
						}

						dec = 0;
						while (world->vilains[dec] != NULL)
						{
							world->vilains[dec]->positionDst.x -= 1;
							dec++;
						}

					}
				}
/*
				else
				{
					//PAS A JOUR
					//Ca avance vers la gauche... + test de fin du monde a gauche (useless ici)
					if (ecran->x_world > 0)
					{
						ecran->x_world -= 1;
						icepeak->positionDst.x += 1;
						bvessel1->positionDst.x += 1;
						bvessel2->positionDst.x += 1;
						Balloon->positionDst.x += 1;
						plateform->positionDst.x += 1;
					}
				}
*/
			}
			else
				world->hero->positionDst.x += 1;
		}
		else
		{
			if ((world->hero->positionDst.x +
				world->hero->sprites[world->hero->current_sprite]->width)
				< ecran->width)
				world->hero->positionDst.x += 1;
		}


		SDL_Delay(50);
	}


	free_everything_decor(background);
	free_decors_in_world(world);

	free_peoples_in_world(world);

	//free_structure_char_array(tab_x_running);																	

	free_world(world);
	free_screen(ecran);


	SDL_Quit();

    return EXIT_SUCCESS;
}
